VERSION 5.00
Begin VB.Form fScreen 
   BorderStyle     =   0  'None
   ClientHeight    =   1200
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1515
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   FillStyle       =   0  'Solid
   FontTransparent =   0   'False
   MousePointer    =   2  'Cross
   ScaleHeight     =   80
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   101
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
End
Attribute VB_Name = "fScreen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**********************
'* Project Lens (v2)  *
'* Carles P.V. - 2003 *
'**********************



Option Explicit

'-- Private API declarations:

Private Declare Function timeGetTime Lib "winmm.dll" () As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function SelectClipRgn Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Const RGN_DIFF As Long = 4

Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Const SW_SHOWMAXIMIZED As Long = 3

'-- Private DIBs and variables:

Private Const LENS_R As Long = 150 ' Lens radius
Private Const LENS_F As Long = 100 ' Lens factor

Private DIB32DeskTop As New cDIB32 ' Buffer DIB (whole DeskTop)
Private DIB32Lens    As New cDIB32 ' Lens processing DIB
Private DIB32LensTmp As New cDIB32 ' Lens processing DIB restoration

Private DskW As Long, DskH As Long ' DeskTop dimensions
Private xL As Long, xLst As Long   ' Current and last Lens x positions
Private yL As Long, yLst As Long   ' Current and last Lens y positions
Private dx As Long, dy As Long     ' x and y increments (animation)

Private t        As Long           ' Timer (animation)
Private bExit    As Boolean        ' [Exit] loop flag (animation)
Private bByMouse As Boolean        ' [By mouse] movement flag





Private Sub Form_Load()
    
    '-- Important notification...
    If (App.LogMode <> 1) Then
        MsgBox "Please, compile me", vbExclamation, "Lens"
        Unload Me
        Exit Sub
    End If
    
    '-- Create/Load desktop DIB (Back buffer)
    DIB32DeskTop.Create Screen.Width \ Screen.TwipsPerPixelX, Screen.Height \ Screen.TwipsPerPixelY
    DIB32DeskTop.LoadBlt GetDC(0)
    
    '-- Create Lens DIBs (Lens rectangles. Processing/Restoration)
    DIB32Lens.Create 2 * LENS_R + 1, 2 * LENS_R + 1
    DIB32LensTmp.Create 2 * LENS_R + 1, 2 * LENS_R + 1
        
    '-- 'Set' DeskTop area
    DskW = DIB32DeskTop.Width - 1
    DskH = DIB32DeskTop.Height - 1
    
    '-- Show this form
    ShowWindow hwnd, SW_SHOWMAXIMIZED
    
    '-- Build LookUp table
    If (MsgBox("Convex ?", vbYesNo Or vbInformation Or vbDefaultButton1, "Lens") = vbYes) Then
        DIB32_Lens_BuildLookUpTable LENS_R, LENS_F, -1
      Else
        DIB32_Lens_BuildLookUpTable LENS_R, LENS_F, 0
    End If
    
    If (MsgBox("Animation mode ?", vbYesNo Or vbInformation Or vbDefaultButton2, "Lens") = vbYes) Then

        '// Animation loop...
        
        '-- Define x/y increments
        dx = 3
        dy = 3
        
        '-- Start looping...
        Do
            If (timeGetTime - t >= 0) Then ' Frame delay [ms] (Max. speed)
                t = timeGetTime
                
                '-- Process and refresh
                RefreshRect xL, yL
                
                '-- Check bounds
                xL = xL + dx
                If (xL < 0) Then xL = 0: dx = -dx
                If (xL > DskW) Then xL = DskW: dx = -dx
                yL = yL + dy
                If (yL < 0) Then yL = 0: dy = -dy
                If (yL > DskH) Then yL = DskH: dy = -dy
                
                '-- Let Windows do something more...
                DoEvents
            End If
            
        '-- Exit or loop again ?
        Loop Until (bExit = -1)
        Unload Me
        
      Else
        '-- No animation mode...
        bByMouse = -1
    End If
End Sub

Private Sub Form_Paint()
    '-- Called after ShowWindow
    DIB32DeskTop.Paint hDC
End Sub

'--------------------------------------------------------------------------------------------------
' DblClick to Exit / Unload
'--------------------------------------------------------------------------------------------------

Private Sub Form_DblClick()
    If (bByMouse) Then
        Unload Me
      Else
        bExit = -1
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    '-- Destroy DIBs
    Set DIB32DeskTop = Nothing
    Set DIB32Lens = Nothing
    Set DIB32LensTmp = Nothing
    '-- Free this form
    Set fScreen = Nothing
End Sub

'--------------------------------------------------------------------------------------------------
' User moves the Lens
'--------------------------------------------------------------------------------------------------

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    If (bByMouse) Then
        
        '-- Check bounds
        If (x < 0) Then x = 0 Else If (x > DskW) Then x = DskW
        If (y < 0) Then y = 0 Else If (y > DskH) Then y = DskH
        
        '-- Process and refresh
        RefreshRect x, y
    End If
End Sub

'--------------------------------------------------------------------------------------------------
' Processing/Refreshing
'--------------------------------------------------------------------------------------------------

Private Sub RefreshRect(ByVal x As Long, ByVal y As Long)

  Dim hRgn1 As Long
  Dim hRgn2 As Long
    
    '-- Restore DIB32LensTmp DIB from Buffer main DIB (DIB32DeskTop)
    DIB32LensTmp.LoadBltRect DIB32DeskTop.hDIBDC, 0, 0, 2 * LENS_R + 1, 2 * LENS_R + 1, x - LENS_R, y - LENS_R
    
    '-- Process: Call DIB32_Lens passing two DIBs:
    '   - Src. DIB: DIB32LensTmp (previously restored)
    '   - Dst. DIB: DIB32Lens    (our final processed DIB)
    DIB32_Lens DIB32LensTmp, DIB32Lens
    
    '-- Create restoration regions (avoid flickering):
    '   - Restoration region
    '   - Refreshing region (Lens)
    hRgn1 = CreateRectRgn(xLst - LENS_R, yLst - LENS_R, xLst + LENS_R, yLst + LENS_R)
    hRgn2 = CreateRectRgn(x - LENS_R, y - LENS_R, x + LENS_R, y + LENS_R)
    CombineRgn hRgn1, hRgn1, hRgn2, RGN_DIFF
    
    '-- Restore last painted rectangle
    SelectClipRgn hDC, hRgn1
    DIB32DeskTop.PaintRect hDC, xLst - LENS_R, yLst - LENS_R, 2 * LENS_R + 1, 2 * LENS_R + 1, xLst - LENS_R, yLst - LENS_R
    DeleteObject hRgn1
    
    '-- Refresh current rectangle (Lens)
    SelectClipRgn hDC, hRgn2
    DIB32Lens.Paint hDC, x - LENS_R, y - LENS_R
    DeleteObject hRgn2
    
    '-- Save last position
    xLst = x
    yLst = y
End Sub
